/**
 * CSCI 201 - Homework 8
 * 
 * @author Your Name
 */

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

// Comment out when you complete Parts 2 or 3
import java.util.TreeMap;

/**
 * Implements a binary search tree which may or may not be
 * an AVL tree (depending on whether Part 3 is completed).
 * Each node in the tree represents a key-value pair.
 * 
 * There are also a few static methods to (1) import the
 * text in a file and (2) to find repeated words in the
 * text (Part 1).
 */
public class DIYTreeMap<K extends Comparable<K>, V> {

  /**
   * Internal class used to represent a node (for Parts 2 and 3).
   */
  class Node {
    public K key;
    public V value;
    public Node left;
    public Node right;
    public int height; // for Part 3

    /**
     * Creates a Node from a key-value pair.
     * 
     * @param key   - key at this node in the BST.
     * @param value - value to associate with this key.
     */
    public Node(K key, V value) {
      this.key = key;
      this.value = value;
      left = null;
      right = null;
      height = 0;
    }
  }

  private Node root; // root of the tree

  /**
   * Constructs an empty binary search tree.
   */
  DIYTreeMap() {
    root = null;
  }

  // TODO (Part 2)
  public void put(K key, V value) {
  }

  // TODO (Part 2)
  public V get(K key) {
    return null;
  }

  /**
   * Returns a string representation of the tree
   * using pre-order traversal.
   * 
   * @return string representation of the tree.
   */
  public String toString() {
    return toString("", root);
  }

  /**
   * Returns a string representation of the subtree.
   * 
   * @param padding - spacing and vertical bars to print before the node.
   * @param node    - the root of the subtree to print.
   * @return appended line to print for this node (and child nodes).
   */
  private String toString(String padding, Node node) {
    if (node == null) {
      return "";
    }

    String result = padding + "└──" + node.toString() + "\n";

    padding += "│    ";
    result += toString(padding, node.left);
    result += toString(padding, node.right);

    return result;
  }

  /**
   * Returns a string with all nodes as they appear in pre-order traversal.
   * This is needed to test what the tree looks like for Part 3,
   * so please don't delete or modify this method.
   * 
   * @param node - starting node (use null to start at the root).
   * @return node information printed in pre-order.
   */
  public String toStringForTesting(Node node) {
    if (node == null) {
      node = root;
    }
    String result = "";
    result += "(" + node.key.toString() + ":" + node.value.toString() + ")";
    if (node.left != null)
      result += toStringForTesting(node.left);
    if (node.right != null)
      result += toStringForTesting(node.right);
    return result;
  }

  /**
   * Imports text from a file, removing a few punctuation characters.
   * 
   * @param filename - file to read.
   * @return processed text (all lowercase).
   */
  public static String importText(String filename) {
    String text = "";
    try {
      File file = new File(filename);
      Scanner scanner = new Scanner(file);
      while (scanner.hasNextLine()) {
        String line = scanner.nextLine();
        if (!line.isEmpty()) {
          text += line;
        }
      }
      scanner.close();
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    }

    // process punctuation
    String[] punctuation = { "--", ".", "  ", ",", "\"", "'", "-" };
    String[] replacements = { "-", " ", " ", "", "", "", " " };
    for (int i = 0; i < punctuation.length; i++) {
      text = text.replace(punctuation[i], replacements[i]);
    }

    return text.toLowerCase();
  }

  /**
   * Returns the words which appear more than twice in some text.
   * 
   * @param text - text to process, assumed to be in lower-case.
   * 
   * @return list of all words which appear more than twice in the text.
   */
  public static ArrayList<String> getRepeatedWords(String text) {
    // TODO find words appearing more than twice in the text
    // using either the built-in TreeMap (Part 1) or your
    // own version (Part 2) or your own balanced version (Part 3).
    return null;
  }

  /**
   * Test your DIYTreeMap and "getRepeatedWords" method here.
   * 
   * @param args (not used).
   */
  public static void main(String[] args) {
    String text = importText("pale-blue-dot.txt");
    System.out.println(text);
    ArrayList<String> words = getRepeatedWords(text);
    System.out.println(words);
  }
}